//+------------------------------------------------------------------+
//|                                               Price_MA_CROSS.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double Lots              =  0.1;   //  
extern double TakeProfit        =  50;  
extern double StopLoss          =  30; 
extern int    X             =  5;  
extern int    SignalBar     =  1;  
extern int    MAperiod      =  14;
extern int    MAmode        =  1;
extern int    MAprice       =  0;





//----------------------------------   ----------------------------
int        Magic          =    7771;        // Magic number
string     TradeComment   =    "";         //    
string     Expert         =    "MACROSS";  //  
int        Slippage       =    4;          // 
int        PrevTime=0;

   


 

int    OrdersPerSymbol=0, OrdersBUY=0, OrdersSELL=0, ticket, Operation=0, trigger=0, cnt;
double  Lot, SL,TP,FastMA1,FastMA2,SlowMA1,SlowMA2,price_holder;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
 OrdersPerSymbol=0; OrdersBUY=0; OrdersSELL=0; Operation=0;  Lot=Lots;  Operation=0;
 
 if (PrevTime!=Time[0])  
 {
   FastMA1=iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,SignalBar);
   FastMA2=iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,SignalBar+1); 
   SlowMA1=iMA(NULL,0,MAperiod,0,MAmode,MAprice,SignalBar); 
   SlowMA2=iMA(NULL,0,MAperiod,0,MAmode,MAprice,SignalBar+1); 
 
   if (FastMA2>=SlowMA2 && FastMA1+X*Point<SlowMA1) Operation=11;
   if (FastMA2<=SlowMA2 && FastMA1>SlowMA1+X*Point) Operation=22;
   PrevTime=Time[0];
 }
 

                       
 int total=OrdersTotal();
 for(cnt=total-1;cnt>=0;cnt--)
 {
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
   if( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
   {
     int openticket = OrderTicket();
     if(OrderType()==OP_BUY && Operation==111)
     {
       ticket=OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,Blue);
       if(ticket<0)
       {
         Print("OrderClose of BuyOrder failed with error #",GetLastError());
         Comment("OrderClose of BuyOrder failed with error #",GetLastError());                                                               
       }         
     }          
     if(OrderType()==OP_SELL && Operation==222)
     {          
       ticket = OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,Red);
       if(ticket<0)
       {     
         Print("OrderClose of SellOrder failed with error #",GetLastError());
         Comment("OrderClose of BuyOrder failed with error #",GetLastError());                        
       }                             
     }     
   }  
   }       
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
     if( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
     {
       OrdersPerSymbol++;
       if(OrderType()==OP_BUY) OrdersBUY++;
       if(OrderType()==OP_SELL) OrdersSELL++;            
     }
   } 

   
   if (Operation==22 && OrdersBUY<1)
   {
     ticket=OrderSend(Symbol(),OP_BUY,Lot,NormalizeDouble(Ask,Digits),Slippage,0,0,TradeComment,Magic,Blue);
     if(ticket<0)
     {
       Print("OrderSend failed with error #",GetLastError());
     }
     else  {Operation=0; trigger=0;}//SendMail("from your expert", "Open BUY at "+DoubleToStr(Ask,Digits) +  ";  SL = " + SL + ";  TP = " + TP);
   }
   if (Operation==11  && OrdersSELL<1 )
   {
      ticket=OrderSend(Symbol(),OP_SELL,Lot,NormalizeDouble(Bid,Digits),Slippage,0,0,TradeComment,Magic,Red);
      if(ticket<0)
      {
        Print("OrderSend failed with error #",GetLastError());
      }
      else  {Operation=0; trigger=0;}//SendMail("from your expert", "Open SELL at "+DoubleToStr(Ask,Digits) +  ";  SL = " + SL + ";  TP = " + TP);}
   }    
   
   
   
   
   Sleep(1000);
   RefreshRates();
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
     if( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
     {

       if(OrderType()==OP_BUY && ((OrderStopLoss()==0 && StopLoss!=0) || (OrderTakeProfit()==0 && TakeProfit!=0)))
       {
          if (StopLoss==0) SL=0; else SL=NormalizeDouble(Ask-StopLoss*Point, Digits);
          if (TakeProfit==0) TP=0; else TP=NormalizeDouble(Ask+TakeProfit*Point, Digits);
          if (!OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,0,Blue)) Print("OrderModify failed with error #",GetLastError());   
       }  
       if(OrderType()==OP_SELL && ((OrderStopLoss()==0 && StopLoss!=0) || (OrderTakeProfit()==0 && TakeProfit!=0))) 
       {
          if (StopLoss==0) SL=0; else SL=NormalizeDouble(Bid+ StopLoss*Point, Digits);
          if (TakeProfit==0) TP=0; else TP=NormalizeDouble(Bid-TakeProfit*Point, Digits);
          if (!OrderModify(OrderTicket(),OrderOpenPrice(),SL,TP,0,Red)) Print("OrderModify failed with error #",GetLastError());
       }       
     }
   } 
   
   
   
   
  return(0);
     
    

  }
//+------------------------------------------------------------------+


